--- amavisd.orig	Mon Apr 25 01:23:32 2005
+++ amavisd	Fri Apr 29 16:46:49 2005
@@ -3654,19 +3654,7 @@
   if (!defined($msg)) {
     # existing header empty
-  } elsif (!exists($self->{edit}) || !scalar(%{$self->{edit}})) {
-    # no edits needed, do it the fast way
-    if ($is_mime) {
-      # NOTE: can't use method print_header, as it assumes file glob
-      for my $h (@header)
-        { $out_fh->print($h) or die "sending mail header2: $!" }
-    } else {  # assume file handle
-      my($ln);  # copy header only, line by line
-      for (undef $!; defined($ln=$msg->getline) && $ln ne $eol; undef $!)
-        { $out_fh->print($ln) or die "sending mail header3: $!" }
-      defined $ln || $!==0  or die "Error reading mail header: $!";
-    }
-  } else {  # header edits are required
+  } else {
     push(@header, $eol)  if $is_mime;  # append empty line as end-of-header
-    my($curr_head, $next_head); undef $!;
+    local($1,$2); my($curr_head,$next_head); my($illcnt) = 0; undef $!;
     while (defined($next_head = $is_mime ? shift @header : $msg->getline)) {
       if ($next_head =~ /^[ \t]/) { $curr_head .= $next_head }  # folded
@@ -3675,4 +3663,5 @@
         } elsif ($curr_head !~ /^([!-9;-\176]+)[ \t]*:(.*)\z/s) {
           # invalid header, but we don't care
+          $curr_head =~ s{\n [ \t]* (?= \n )}{}gsx  and $illcnt++;
           $out_fh->print($curr_head) or die "sending mail header4: $!";
         } else {                     # count, edit, or delete
@@ -3682,4 +3671,6 @@
           $received_cnt++  if $field_name_lc eq 'received';
           if (!exists($self->{edit}{$field_name_lc})) { # unchanged
+            # unfold illegal all-whitespace continuation lines
+            $curr_head =~ s{\n [ \t]* (?= \n )}{}gsx  and $illcnt++;
             $out_fh->print($curr_head) or die "sending mail header5: $!";
           } else {
@@ -3688,6 +3679,7 @@
               chomp($field_body);
               ### $field_body =~ s/\n([ \t])/$1/g;  # unfold
-              $out_fh->print(hdr($field_name, &$edit($field_name,$field_body)))
-                or die "sending mail header6: $!";
+              my($subst) = hdr($field_name, &$edit($field_name,$field_body));
+              $subst =~ s{\n [ \t]* (?= \n )}{}gsx  and $illcnt++;
+              $out_fh->print($subst) or die "sending mail header6: $!";
             }
           }
@@ -3699,4 +3691,6 @@
     }
     defined $next_head || $!==0  or die "Error reading mail header: $!";
+    do_log(0, "INFO: unfolded $illcnt illegal all-whitespace ".
+              "continuation lines")  if $illcnt;
   }
   $str = '';
